#include <iostream.h>
#include <iomanip.h>
#include <fstream.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "lparx.h"
ifelse(NDIM,2,@
#include "cadez_hierarchy2.h"
#include "cadez_dsolvs2.h"
@,NDIM,3,@
#include "cadez_hierarchy3.h"
#include "cadez_dsolvs3.h"
@)
//#include "symdata2D.h"

ifelse(NDIM,2,@
//#define MINSIZE 128
#define MINSIZE Point2(128)
@,NDIM,3,@
//#define MINSIZE 16
#define MINSIZE Point3(16)
@)

ifelse(NDIM,2,@
#define I_X 0
#define I_Y 1
@,NDIM,3,@
#define I_W 0
#define I_X 1
#define I_Y 2
@)

RegionX *MyUniformPartition(const RegionX &, int &,
										const PointX mincut = PointX(2));

F_ID ID_Residual(cadez_discretization&,int);

ifelse(NDIM,2,@
extern "FORTRAN" int cadez_coord_init(double *, double *, double *,
			double *, double *, double *, double *, double *, double *,
			double *, double *, double *, double *, double *, double *,
			double *, double *, double *, int *, int *,
			const double &, const double &, const double &,
			const double &, const double &, const double &);

extern "FORTRAN" void cadez_diffcoef(double *, double *, double *,
			double *, double *, double *, double *, double *, double *,
			double *, double *, double *, int *, int *, int *,
			const double &, const double &);

extern "FORTRAN" void cadez_id(const double &, const double &,
			const double &, const double &, const double &,
			double *, double *, double *, double *, int *, int *);
@,NDIM,3,@
extern "FORTRAN" int cadez_coord_init(double *, double *, double *,
			double *, double *, double *, double *, double *, double *,
			double *, double *, double *, double *, double *, double *,
			double *, double *, double *, double *, double *, double *,
			double *, int *, int *, const double &, const double &,
			const double &, const double &, const double &,
			const double &, const double &);

extern "FORTRAN" void cadez_diffcoef(double *, const double &, double *,
			double *, double *, double *, double *, double *, double *,
			double *, double *, double *, double *, double *, double *,
			int *, int *, int *, const double &, const double &);

extern "FORTRAN" void cadez_id(const double &, const double &,
			const double &, const double &, const double &, const double &,
			const double &, const double &, const double &, const double &,
			const double &, const double &, const double &,
			double *, double *, double *, double *, double *, int *, int *);
@)

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	F_ID operator overloading routines.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
F_ID F_ID::operator*(double scale) {
	F_ID newf = *this;
	newf.Psi *= scale;
return newf;
} // F_ID::operator*(double)
int F_ID::operator>(F_ID rhs) {
	return ((Psi > rhs.Psi));
} // F_ID::operator>(F_ID)
int F_ID::operator<(F_ID rhs) {
	return ((Psi < rhs.Psi));
} // F_ID::operator<(F_ID)
int F_ID::operator==(double rhs) {
	return ((Psi == rhs));
} // F_ID::operator==(F_ID)

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Send general Cadez coordinate information to the output stream in a nicely
// formatted fashion.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ostream& operator<<(ostream& s, cadez_domain& c) {
	const long flagsave = s.setf(ios::scientific|ios::right);
	const int precsave = s.precision(6);
	s << "======================================"
			"======================================\n";
	s << "|   Alpha = " << setw(13) << c.Alpha
			<< "     Beta = " << setw(13) << c.Beta
			<< "                         |\n";
	s << "|   ZETAp = " << setw(13) << c.ZETAp
			<< "    ZETAm = " << setw(13) << c.ZETAm
			<< "                         |\n";
	s << "|   ETAzp = " << setw(13) << c.ETAzp
			<< "    ETAzm = " << setw(13) << c.ETAzm
			<< "  ETAmax = " << setw(13) << c.ETAmax << " |\n";
	s << "|     XIi = " << setw(13) << c.XIi
			<< "      XIf = " << setw(13) << c.XIf
			<< "                         |\n";
	s << "|   Zsing = " << setw(13) << c.Zsing
			<< "  RHOsing = " << setw(13) << c.RHOsing
			<< "                         |\n";
	s << "| ETAsing = " << setw(13) << c.ETAsing
			<< "   XIsing = " << setw(13) << c.XIsing
			<< "                         |\n";
	s << "======================================"
			"======================================\n";
	s.flags(flagsave);
	s.precision(precsave);
	return s;
} // operator<<


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	Initializer for cadez_discretization:
//    Set reference to the general cadez coordinate information in cdomain.
//		Sets up domain_R1, domain_R2, & domain_R3 to their correct values and
//			sets the discretization information.
//		"Zero's" the partitioning information which will be set by 
//			cadez_discretization::domain_partition.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
ifelse(NDIM,2,@
cadez_discretization::cadez_discretization(cadez_domain& cd, Grid_Type gt,
		int nep, int nem, int ne3, int nsp, int nsm) : 
@,NDIM,3,@
cadez_discretization::cadez_discretization(cadez_domain& cd, Grid_Type gt,
		int nep, int nem, int ne3, int nsp, int nsm, int nphi) : 
@)
//
	cdomain(cd), Grid_Kind(gt) {
ifelse(NDIM,2,@
	domain_R1 = Region2(1,1-nep,nsp,0);
	domain_R2 = Region2(nsp+1,1-nem,nsp+nsm,0);
	domain_R3 = Region2(1,1,nsp+nsm,ne3);
@,NDIM,3,@
	domain_R1 = Region3(1,1,1-nep,nphi,nsp,0);
	domain_R2 = Region3(1,nsp+1,1-nem,nphi,nsp+nsm,0);
	domain_R3 = Region3(1,1,1,nphi,nsp+nsm,ne3);
@)
//
	deta = (cd.ETAmax - cd.ETAsing)/ne3;
	const int ns = nsp + nsm;
	ds = 1.0/ns;
ifelse(NDIM,3,@
	dphi = (2.0*M_PI)/nphi;
@)
	StoXI_f = (ns*(cd.XIf - (ns*cd.XIsing)/nsp))/nsm;
	StoXI_g = ((ns*ns*cd.XIsing)/nsp - nsp*cd.XIf)/nsm;
//
	Ninteriors = 0;
	interiors = 0;
	extents = 0;
	fills = 0;
	coarse_interiors = 0;
	coarse_extents = 0;
	coarse_fills = 0;
	coarse_prolong = 0;
	mapping = 0;
	dup_cnt = 0;
	dup_pts = 0;
	dup_value = 0;
	dup_norm = 0;
} // cadez_discretization::cadez_discretization(cadez_domain& cd,


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Terminator for cadez_discretization.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
cadez_discretization::~cadez_discretization(){
	delete [] interiors;
	delete [] extents;
	delete [] fills;
	delete [] coarse_interiors;
	delete [] coarse_extents;
	delete [] coarse_fills;
	delete [] coarse_prolong;
	delete mapping;
	delete [] dup_pts;
	delete dup_value;
	delete dup_norm;
} // cadez_discretization::~cadez_discretization


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Create a new partitioning for the Cadez domain.
//		Assumes P processors are to be used.
//		minsize is the minimum partitioning extent in any direction.  No
//			sub-partitions will be made smaller than the given value for each
//			dimension.
//		coarsen is set to zero if no interpolation to a coarser grid will be
//			needed in a given Cadez region.
//		domain_partition returns the total number of partitions created.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
int cadez_discretization::domain_partition(const int P,
														const PointX minsize,
														int coarsen, int baseP,
														int BSlevels) {
//------------------------------------------------------------------------------
// Partition the Cadez interior using a crude load balancing algorithm.
//------------------------------------------------------------------------------
//
// Compute Cadez region sizes for load balancing.
	const int size1 = domain_R1.size();
	const int size2 = domain_R2.size();
	const int size3 = domain_R3.size();
	const int size = size1 + size2 + size3;
//
// Estimate the number of partitions for Cadez Regions 1 & 2.
	int p1 = (P*size1)/size;
	int p2 = (P*size2)/size;
	p1 = (p1 > 1) ? p1 : 1;	// make sure Region 1 has at least one partition.
	p2 = (p2 > 1) ? p2 : 1;	// make sure Region 2 has at least one partition.
//
// Make sure the top level Regions 1 & 2 consist of only 1 partition
	if(!coarsen) p1 = p2 = 1;
//
	if(P == 1) { // Make sure at least 1 processor is free for Cadez Region 3
	} else if(P == 2) {
		p1 = p2 = 1;
	} else if(P - p1 - p2 < 1) {
		if(p1 > p2) { --p1;} else { --p2;}
	}
//
// Make sub-partitions for Cadez Regions 1 & 2.
	RegionX *tr1 = MyUniformPartition(domain_R1, p1, minsize);
	RegionX *tr2 = MyUniformPartition(domain_R2, p2, minsize);
//
// Determine number of processors to use for Cadez Region 3.
		// Fraction of processors needed for Cadez Regions 1 & 2.
	double ratio12 = double(P*(size1 + size2))/size;
	int p3 = P;
	if(ratio12 == 0.0) {	// Use ALL processors for Cadez Region 3.
	} else if(ratio12 <= 1.5) {
		p3 -= 1;				// Use 1 processor for Cadez Regions 1 & 2.
	} else if(ratio12 <= 2.5) {
		p3 -= 2;				// Use 2 processors for Cadez Regions 1 & 2.
	} else {
		p3 -= p1 + p2;		// Use p1 processors for Cadez Region 1. 
								// Use p2 processors for Cadez Region 2. 
								// Use the remaining processors for Cadez Region 3. 
	}
//
// Make sub-partitions for Cadez Region 3 makeing sure p3 is at least 1.
	p3 = (p3 > 1) ? p3 : 1;
//
// Make sure the top level Region 3 consists of only 1 partition
	if(!coarsen && (ratio12 == 0.0 || BSlevels == 1)) p3 = 1;
//
	RegionX *tr3 = MyUniformPartition(domain_R3, p3, minsize);
//
// Total number of new partitions.
	const int Nint_new = p1 + p2 + p3;
//------------------------------------------------------------------------------
// Map regions to processors.
//------------------------------------------------------------------------------
	int *map_new = new int[Nint_new];	// Allocate new processor mapping array.
	int *mapindex = map_new;
	int i = 0;
	int count = 0;		// Keeps track of which processor to use.
	if(ratio12 != 0.0) {	// Cadez Regions 1 & 2 exists, assign them procs.
		if(p3 == P - 1) {	// Only 1 processor is used for Cadez Regions 1 & 2.
			*(mapindex++) = (count % P);
			*(mapindex++) = (count++ % P);
			baseP_R1 = baseP_R2 = 0;
			baseP_R3 = 1 % P;
		} else if(p3 == P - 2) {	// 2 processors for Cadez Regions 1 & 2.
			if(p1 == p2) { // Processors are split evenly.
				*(mapindex++) = (count++ % P); // Cadez Region 1 uses 1 proc.
				*(mapindex++) = (count++ % P); // Cadez Region 2 uses 1 proc.
			} else if(p1 > p2) {
				*(mapindex++) = (count++ % P); // Cadez Region 1 uses 2 procs.
				*(mapindex++) = (count % P);
				*(mapindex++) = (count++ % P); // Cadez Region 2 uses 2nd proc.
			} else {
				*(mapindex++) = ((count+1) % P);//Cadez Region 1 uses 2nd proc.
				*(mapindex++) = (count++ % P); // Cadez Region 2 uses 2 procs.
				*(mapindex++) = (count++ % P);
			}
			baseP_R1 = 0;
			baseP_R2 = 1 % P;
			baseP_R3 = 2 % P;
		} else {	// Partitions in Cadez Regions 1 & 2 uses a separate processor.
			for(i=0; i < p1; ++i) {
				*(mapindex++) = (count++ % P);
			}
			baseP_R1 = 0;
			for(i=0; i < p2; ++i) {
				*(mapindex++) = (count++ % P);
			}
			baseP_R2 = p1 % P;
			baseP_R3 = (p1 + p2) % P;
		}
	}
   if(baseP != 0) baseP_R3 = baseP;
//	Each partition in Cadez Region 3 uses a separate processor.
	for(i=0; i < p3; ++i) {
		*(mapindex++) = (count++ % P) + baseP;
	}
//
//------------------------------------------------------------------------------
// Allocate space for, and set, the regions describing partitioning of
//	the domain.
//------------------------------------------------------------------------------
	RegionX *int_new = new RegionX[Nint_new];
	RegionX *ext_new = new RegionX[Nint_new];
	RegionX *fil_new = new RegionX[Nint_new];
	RegionX *cint_new = new RegionX[Nint_new];
	RegionX *cext_new = new RegionX[Nint_new];
	RegionX *cfil_new = new RegionX[Nint_new];
	RegionX *intseq = int_new;
	RegionX *extseq = ext_new;
	RegionX *filseq = fil_new;
	RegionX *cintseq = cint_new;
	RegionX *cextseq = cext_new;
	RegionX *cfilseq = cfil_new;
ifelse(NDIM,3,@
//	set up Point3 for adding periodicity to phi component of fill regions
	Point3 periodic(0); periodic(I_W) = 1;
@)
//
// Set partition regions for Cadez Region 1.
	for(i=0; i < p1; ++i) {
		*intseq = tr1[i];		// Set the interior region.
	// Set the extent and fill regions to be one zone larger than the interior.
		*filseq = *extseq = grow(*intseq,1);
	// Restrice the fill region to the computational domain.
ifelse(NDIM,2,@
		*filseq *= domain_R1;
@,NDIM,3,@
	// Add periodicity to phi coordinate
		*filseq *= grow(domain_R1,periodic);
@)
		if(coarsen == 0) {  // Cadez Region 1 will not be coarsened.
		// If boardering Cadez Region 3 then extend fill into Region 3 by 1 zone.
			if(intseq->upper(I_Y) == 0)
				filseq->upper(I_Y) += 1;
			*cintseq = RegionX();	// Set the coarse interior to empty.
		} else { // Cadez Region 1 will be coarsened.
		// If boardering Cadez Region 3 then extend fill into Region 3.
			if(intseq->upper(I_Y) == 0) {
			// Make sure there are 4 zones for restriction.
				int filext = 4 - tr1[i].extents(I_Y);
				filseq->upper(I_Y) += (filext > 1) ? filext : 1;
			}
		// Set the coarse interior.
			*cintseq = RegionX((tr1[i].lower() + 1)/2,tr1[i].upper()/2);
		}
		++intseq;
		*(extseq++) += *(filseq++);	// Expand extents to include all of fill.
	//
	// Set the coarse extent and fill regions to be one zone larger than
	// the interior.
		*cfilseq = *cextseq = grow(*cintseq,1);
	// Restrice the coarse fill region to the computational domain.
		RegionX cfillbnd((domain_R1.lower() + 1)/2,domain_R1.upper()/2);
ifelse(NDIM,3,@
	// Add periodicity to phi coordinate
		cfillbnd = grow(cfillbnd,periodic);
@)
		*cfilseq *= cfillbnd;
	// If boardering Cadez Region 3 then extend coarse fill into Region 3.
		if(!(cintseq->empty()) && (cintseq->upper(I_Y) == 0)) {
		// Make sure there are 3 zones for prolongation.
			int filext = 3 - cintseq->extents(I_Y);
			cfilseq->upper(I_Y) += (filext > 1) ? filext : 1;
		}
		++cintseq;
	// Expand coarse extents to include all of coarse fill.
		*(cextseq++) += *(cfilseq++);
	}
//
// Set partition regions for Cadez Region 2.
	for(i=0; i < p2; ++i) {
		*intseq = tr2[i];		// Set the interior region.
	// Set the extent and fill regions to be one zone larger than the interior.
		*filseq = *extseq = grow(*intseq,1);
	// Restrice the fill region to the computational domain.
ifelse(NDIM,2,@
		*filseq *= domain_R2;
@,NDIM,3,@
	// Add periodicity to phi coordinate
		*filseq *= grow(domain_R2,periodic);
@)
		if(coarsen == 0) {	// Cadez Region 2 will not be coarsened.
		// If boardering Cadez Region 3 then extend fill into Region 3 by 1 zone.
			if(intseq->upper(I_Y) == 0)
				filseq->upper(I_Y) += 1;
			*cintseq = RegionX();	// Set the coarse interior to empty.
		} else {	// Cadez Region 2 will be coarsened.
		// If boardering Cadez Region 3 then extend fill into Region 3
			if(intseq->upper(I_Y) == 0) {
			// Make sure there are 4 zones for restriction.
				int filext = 4 - tr2[i].extents(I_Y);
				filseq->upper(I_Y) += (filext > 1) ? filext : 1;
			}
		// Set the coarse interior.
			*cintseq = RegionX((tr2[i].lower() + 1)/2,tr2[i].upper()/2);
		}
		++intseq;
		*(extseq++) += *(filseq++);	// Expand extents to include all of fill.
	//
	// Set the coarse extent and fill regions to be one zone larger than
	// the interior.
		*cfilseq = *cextseq = grow(*cintseq,1);
	// Restrice the coarse fill region to the computational domain.
		RegionX cfillbnd((domain_R2.lower() + 1)/2,domain_R2.upper()/2);
ifelse(NDIM,3,@
	// Add periodicity to phi coordinate
		cfillbnd = grow(cfillbnd,periodic);
@)
		*cfilseq *= cfillbnd;
	// If boardering Cadez Region 3 then extend coarse fill into Region 3.
		if(!(cintseq->empty()) && (cintseq->upper(I_Y) == 0)) {
		// Make sure there are 3 zones for prolongation.
			int filext = 3 - cintseq->extents(I_Y);
			cfilseq->upper(I_Y) += (filext > 1) ? filext : 1;
		}
		++cintseq;
	// Expand coarse extents to include all of coarse fill.
		*(cextseq++) += *(cfilseq++);
	}
//
// Set partition regions for Cadez Region 3.
	for(i=0; i < p3; ++i) {
		*intseq = tr3[i];		// Set the interior region.
	// Set the extent and fill regions to be one zone larger than the interior.
		*filseq = *extseq = grow(*intseq,1);
	// Restrice the fill region to the computational domain.
ifelse(NDIM,2,@
		*filseq *= domain_R3;
@,NDIM,3,@
	// Add periodicity to phi coordinate
		*filseq *= grow(domain_R3,periodic);
@)
	// If boardering Cadez Region 1 or 2 then extend fill into Region 3 or 2
	// by 1 zone.
		if(intseq->lower(I_Y) == 1)
			filseq->lower(I_Y) -= 1;
		++intseq;
		*(extseq++) += *(filseq++);	// Expand extents to include all of fill.
		if(coarsen == 0 && domain_R1.empty() && domain_R2.empty()) {
		// Cadez Region 3 will not be coarsened.
			*cintseq = RegionX();	// Set the coarse interior to empty.
		} else {	// Cadez Region 3 will be coarsened, set the coarse interior.
			*cintseq = RegionX((tr3[i].lower() + 1)/2,tr3[i].upper()/2);
		}
	//
	// Set the coarse extent and fill regions to be one zone larger than
	// the interior.
		*cfilseq = *cextseq = grow(*cintseq,1);
	// Restrice the coarse fill region to the computational domain.
		RegionX cfillbnd((domain_R3.lower() + 1)/2,domain_R3.upper()/2);
ifelse(NDIM,3,@
	// Add periodicity to phi coordinate
		cfillbnd = grow(cfillbnd,periodic);
@)
		*cfilseq *= cfillbnd;
	// If boardering Cadez Region 1 or 2 then extend coarse fill into
	// Region 1 or 2.
		if(!(cintseq->empty()) && (cintseq->lower(I_Y) == 1))
			cfilseq->lower(I_Y) -= 1;
		++cintseq;
	// Expand coarse extents to include all of coarse fill.
		*(cextseq++) += *(cfilseq++);
	}
// Delete the temporary partitions for Cadez Regions 1, 2, & 3,
// along with the old processor mapping, partitionings,
// and coarse partitionings.
	delete [] tr1;
	delete [] tr2;
	delete [] tr3;
	delete mapping;
	delete [] interiors;
	delete [] extents;
	delete [] fills;
	delete [] coarse_interiors;
	delete [] coarse_extents;
	delete [] coarse_fills;
	delete [] coarse_prolong;
// Assign the new processor mapping, partitionings, and coarse partitionings.
	mapping = map_new;
	interiors = int_new;
	extents = ext_new;
	fills = fil_new;
	coarse_interiors = cint_new;
	coarse_extents = cext_new;
	coarse_fills = cfil_new;
	coarse_prolong = cint_new;	// Use normal interior for non-adaptive prolong.
// Set the current number of partitions & return this value.
	Ninteriors = Nint_new;
	return Ninteriors;
} // cadez_discretization::domain_partition


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Initialize the basic coordinate information for each partition.
// Initialize all XArrays and fill them with "reasonable" initial values.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void cadez_hierarchy::initialize_level(const int lev, const double mask,
													const int Interp_Sol,
													const int Same_Uniform_Grid,
													cadez_discretization * Old_Level) {
static TimeSection timer3("initialize()");
timer3.enter_section();
	cadez_discretization & nl = (*this)[lev];
//
	if(Same_Uniform_Grid == 0) {
	//
	//---------------------------------------------------------------------------
	// Allocate Refinement Mask.
	//---------------------------------------------------------------------------
		XAlloc(nl.Refine_Mask,nl.Ninteriors,nl.extents,nl.mapping);
	//
	//---------------------------------------------------------------------------
	// Allocate Basic Coordinate info.
	//---------------------------------------------------------------------------
		Region1 *xregs = new Region1[nl.Ninteriors];
		Region1 *yregs = new Region1[nl.Ninteriors];
ifelse(NDIM,3,@
		Region1 *wregs = new Region1[nl.Ninteriors];
@)
		for(int i = 0; i < nl.Ninteriors ; ++i) {
			xregs[i] = Region1(nl.extents[i].lower(I_X),nl.extents[i].upper(I_X));
			yregs[i] = Region1(nl.extents[i].lower(I_Y),nl.extents[i].upper(I_Y));
ifelse(NDIM,3,@
			wregs[i] = Region1(nl.extents[i].lower(I_W),nl.extents[i].upper(I_W));
@)
		}
		XAlloc(nl.Xi,nl.Ninteriors,xregs,nl.mapping);
		XAlloc(nl.Eta,nl.Ninteriors,yregs,nl.mapping);
ifelse(NDIM,3,@
		XAlloc(nl.Phi,nl.Ninteriors,wregs,nl.mapping);
@)
		XAlloc(nl.X,nl.Ninteriors,xregs,nl.mapping);
		XAlloc(nl.Y,nl.Ninteriors,yregs,nl.mapping);
ifelse(NDIM,3,@
		XAlloc(nl.W,nl.Ninteriors,wregs,nl.mapping);
@)
		XAlloc(nl.JXzc,nl.Ninteriors,xregs,nl.mapping);
		XAlloc(nl.JXzf,nl.Ninteriors,xregs,nl.mapping);
		XAlloc(nl.JYzc,nl.Ninteriors,yregs,nl.mapping);
		XAlloc(nl.JYzf,nl.Ninteriors,yregs,nl.mapping);
ifelse(NDIM,3,@
		XAlloc(nl.JWzc,nl.Ninteriors,wregs,nl.mapping);
		XAlloc(nl.JWzf,nl.Ninteriors,wregs,nl.mapping);
@)
		delete [] xregs;
		delete [] yregs;
ifelse(NDIM,3,@
		delete [] wregs;
@)
	//
		Region2 *xyregs = new Region2[nl.Ninteriors];
		for(i = 0; i < nl.Ninteriors ; ++i) {
			xyregs[i] = Region2(Point2(nl.extents[i].lower(I_X),
																	nl.extents[i].lower(I_Y)),
										Point2(nl.extents[i].upper(I_X),
																	nl.extents[i].upper(I_Y)));
		}
	//
		XAlloc(nl.RHOzc,nl.Ninteriors,xyregs,nl.mapping);
		XAlloc(nl.RHOxf,nl.Ninteriors,xyregs,nl.mapping);
		XAlloc(nl.RHOyf,nl.Ninteriors,xyregs,nl.mapping);
		XAlloc(nl.Zzc,nl.Ninteriors,xyregs,nl.mapping);
		XAlloc(nl.Zxf,nl.Ninteriors,xyregs,nl.mapping);
		XAlloc(nl.Zyf,nl.Ninteriors,xyregs,nl.mapping);
		XAlloc(nl.Volume,nl.Ninteriors,xyregs,nl.mapping);
		XAlloc(nl.CJACzc,nl.Ninteriors,xyregs,nl.mapping);
		XAlloc(nl.CJACxf,nl.Ninteriors,xyregs,nl.mapping);
		XAlloc(nl.CJACyf,nl.Ninteriors,xyregs,nl.mapping);
	//
	//---------------------------------------------------------------------------
	// Allocate Difference Coefficients.
	//---------------------------------------------------------------------------
		XAlloc(nl.LapX,nl.Ninteriors,xyregs,nl.mapping);
		XAlloc(nl.LapY,nl.Ninteriors,xyregs,nl.mapping);
ifelse(NDIM,3,@
		XAlloc(nl.LapW,nl.Ninteriors,xyregs,nl.mapping);
@)
	//
		delete [] xyregs;
	//
	//---------------------------------------------------------------------------
	// Allocate Temporary Variables.
	//---------------------------------------------------------------------------
		XAlloc(nl.TmpC,nl.Ninteriors,nl.coarse_extents,nl.mapping);
	//
	//---------------------------------------------------------------------------
	// Allocate Physical Fields.
	//---------------------------------------------------------------------------
		XAlloc(nl.Psi,nl.Ninteriors,nl.extents,nl.mapping);
		XAlloc(nl.PsiD,nl.Ninteriors,nl.extents,nl.mapping);
		XAlloc(nl.PsiTau,nl.Ninteriors,nl.extents,nl.mapping);
		XAlloc(nl.PsiRes,nl.Ninteriors,nl.extents,nl.mapping);
		XAlloc(nl.PsiC,nl.Ninteriors,nl.coarse_extents,nl.mapping);
		XAlloc(nl.PsiCT,nl.Ninteriors,nl.coarse_extents,nl.mapping);
		XAlloc(nl.KK,nl.Ninteriors,nl.extents,nl.mapping);
	}
//
//------------------------------------------------------------------------------
// Initialize Grids.
//------------------------------------------------------------------------------
//
//	Prepair to copy usefull info from the old discretization if it exists
	if(Old_Level != 0 && Same_Uniform_Grid == 0) {
		cadez_discretization & ol = *Old_Level;
		for_all_1(l,ol.Refine_Mask)
			ol.Refine_Mask(l).fill(1.0);
		end_for_all
		for_all_1(l,nl.Refine_Mask)
		//	Set Refine_Mask to zero wherever no data is copied
			nl.Refine_Mask(l).fill(0.0);
			for_1(m,ol.Refine_Mask)
				nl.Refine_Mask(l).copy(ol.Refine_Mask(m),nl.fills[l]*ol.fills[m]);
			//	Copy over any Grid initialization info which is expensive to
			//	compute
			//	Copy over any field variables to be saved
			end_for
		end_for_all
	} else if(Same_Uniform_Grid == 0) {
	//	Set Refine_Mask to zero wherever no data is copied
		for_all_1(l,nl.Refine_Mask)
			nl.Refine_Mask(l).fill(0.0);
		end_for_all_no_sync
	}
	if(Same_Uniform_Grid == 0) {
	//
	//	Compute Grid info for points which have not been copied only if 
	// we are not using the same uniform grid.
		const double alpha = domain.Alpha;
		const double xising = domain.XIsing;
		const double etasing = domain.ETAsing;
		ifelse(NDIM,3,const double dphi = nl.dphi;)
		const double ds = nl.ds;
		const double deta = nl.deta;
		const double f = nl.StoXI_f;
		const double g = nl.StoXI_g;
		for_all_1(l,nl.Refine_Mask)
ifelse(NDIM,2,@
			int err = cadez_coord_init(nl.Xi(l).data(),nl.Eta(l).data(),
										nl.X(l).data(),nl.Y(l).data(),
										nl.JXzc(l).data(),nl.JXzf(l).data(),
										nl.JYzc(l).data(),nl.JYzf(l).data(),
										nl.RHOzc(l).data(),nl.RHOxf(l).data(),
										nl.RHOyf(l).data(),nl.Zzc(l).data(),
										nl.Zxf(l).data(),nl.Zyf(l).data(),
										nl.Volume(l).data(),nl.CJACzc(l).data(),
										nl.CJACxf(l).data(),nl.CJACyf(l).data(),
										(int *)(nl.extents+l),(int *)(nl.fills+l),
										ds,deta,f,g,xising,etasing);
@,NDIM,3,@
			int err = cadez_coord_init(nl.Phi(l).data(),nl.Xi(l).data(),
										nl.Eta(l).data(),nl.W(l).data(),nl.X(l).data(),
										nl.Y(l).data(),nl.JWzc(l).data(),
										nl.JWzf(l).data(),nl.JXzc(l).data(),
										nl.JXzf(l).data(),nl.JYzc(l).data(),
										nl.JYzf(l).data(),nl.RHOzc(l).data(),
										nl.RHOxf(l).data(),nl.RHOyf(l).data(),
										nl.Zzc(l).data(),nl.Zxf(l).data(),
										nl.Zyf(l).data(),nl.Volume(l).data(),
										nl.CJACzc(l).data(),nl.CJACxf(l).data(),
										nl.CJACyf(l).data(),(int *)(nl.extents+l),
										(int *)(nl.fills+l),dphi,ds,deta,f,g,
										xising,etasing);
@)
			if(err) Abort("initialize","chi2cyl");
			//
ifelse(NDIM,2,@
			cadez_diffcoef(nl.Xi(l).data(),nl.JXzc(l).data(),nl.JXzf(l).data(),
								nl.JYzc(l).data(),nl.JYzf(l).data(),nl.RHOzc(l).data(),
								nl.RHOxf(l).data(),nl.RHOyf(l).data(),nl.Zzc(l).data(),
								nl.CJACyf(l).data(),nl.LapX(l).data(),nl.LapY(l).data(),
								(int *)(nl.extents+l),(int *)(nl.interiors+l),
								(int *)(nl.fills+l),xising,alpha);
@,NDIM,3,@
			cadez_diffcoef(nl.Xi(l).data(),dphi,nl.JXzc(l).data(),
								nl.JXzf(l).data(),nl.JYzc(l).data(),nl.JYzf(l).data(),
								nl.RHOzc(l).data(),nl.RHOxf(l).data(),
								nl.RHOyf(l).data(),nl.Zzc(l).data(),
								nl.CJACzc(l).data(),nl.CJACyf(l).data(),
								nl.LapW(l).data(),nl.LapX(l).data(),nl.LapY(l).data(),
								(int *)(nl.extents+l),(int *)(nl.interiors+l),
								(int *)(nl.fills+l),xising,alpha);
@)
		end_for_all_no_sync
	}
//
//	call data initialization for all patches
	for_all_1(l,nl.Refine_Mask)
ifelse(NDIM,2,@
		cadez_id(domain.Pzp,domain.Pzm,domain.Szp,domain.Szm,domain.Isom,
					nl.KK(l).data(),
					nl.RHOzc(l).data(),nl.Zzc(l).data(),nl.CJACzc(l).data(),
					(int *)(nl.extents+l),(int *)(nl.fills+l));
@,NDIM,3,@
		cadez_id(domain.Pxp,domain.Pyp,domain.Pzp,
					domain.Pxm,domain.Pym,domain.Pzm,
					domain.Sxp,domain.Syp,domain.Szp,
					domain.Sxm,domain.Sym,domain.Szm,domain.Isom,
					nl.KK(l).data(),
					nl.RHOzc(l).data(),nl.Zzc(l).data(),nl.Phi(l).data(),
					nl.CJACzc(l).data(),(int *)(nl.extents+l),(int *)(nl.fills+l));
@)
		GridX(double) & dst1 = nl.PsiD(l);
		BeginFastIndexNDIM(dst1, double);
ifelse(NDIM,2,@
		for_2(i,j,nl.fills[l])
			FastIndex2(dst1,i,j) = 0.0;
		end_for
@,NDIM,3,@
		for_3(i,j,k,nl.fills[l])
			FastIndex3(dst1,i,j,k) = 0.0;
		end_for
@)
		EndFastIndexNDIM(dst1);
	end_for_all_no_sync
//
//	Refine the coarse grid solution first, then copy old fine grid values if any
	if(Interp_Sol != 0) {
		refine_solution(lev);
		if(Old_Level != 0) {
//			for_all_1(l,nl.Refine_Mask)
//				GridX(double) & msk = nl.Refine_Mask(l);
//				BeginFastIndexNDIM(msk, const double);
ifelse(NDIM,2,@
//				for_2(i,j,nl.fills[l])
//					if(FastIndex2(msk,i,j) != 0) 
//				end_for
@,NDIM,3,@
//				for_3(i,j,k,nl.fills[l])
//					if(FastIndex3(msk,i,j,k) != 0) 
//				end_for
@)
//				EndFastIndexNDIM(msk);
//			end_for_all_no_sync
		}
	}
//
//	Set Refine_Mask to its final state.
	for_all_1(l,nl.Refine_Mask)
		nl.Refine_Mask(l).fill(mask);
		nl.PsiTau(l).fill(0.0);
	end_for_all_no_sync
	nl.sync_fields();
timer3.exit_section();
} // cadez_hierarchy::initialize_level


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	Copy boundary data where the interior region of the source partition
//	overlaps the fill region of the destination partition.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void cadez_discretization::fill_patch(XArray1(GridX(double)) & G) {
ifelse(NDIM,3,@
   const int N = domain_R3.extents(I_W);
	Point3 up(0); up(I_W) = N;
	Point3 dn(0); dn(I_W) = -N;
@)
	for_all_1(i,G)
		for_1(j,G)
			if(i != j) G(j).copy(G(i),fills[j]*interiors[i]);
ifelse(NDIM,3,@
			Region3 R = fills[j]*shift(interiors[i],up);
//			G(j).copy(G(i),shift(R,dn),R);
			G(j).copy(G(i),R,shift(R,dn));
			R = fills[j]*shift(interiors[i],dn);
//			G(j).copy(G(i),shift(R,up),R);
			G(j).copy(G(i),R,shift(R,up));
@)
		end_for
	end_for_all
} // cadez_discretization::fill_patch


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	Synchronize physical fields with auxilliary fields.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void cadez_discretization::sync_fields() {
	for_all_1(l,Psi)
		const GridX(double) & src = PsiD(l);
		GridX(double) & dst = Psi(l);
		BeginFastIndexNDIM(src, const double);
		BeginFastIndexNDIM(dst, double);
ifelse(NDIM,2,@
		for_2(i,j,fills[l])
			FastIndex2(dst,i,j) = 1.0 + FastIndex2(src,i,j);
//			Psi(l)(i,j) = 1.0 + PsiD(l)(i,j);
		end_for
@,NDIM,3,@
		for_3(i,j,k,fills[l])
			FastIndex3(dst,i,j,k) = 1.0 + FastIndex3(src,i,j,k);
//			Psi(l)(i,j,k) = 1.0 + PsiD(l)(i,j,k);
		end_for
@)
		EndFastIndexNDIM(src);
		EndFastIndexNDIM(dst);
	end_for_all
} // cadez_discretization::sync_fields


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Send information about a particular cadez_discretization to the output
// stream in a nicely formatted fashion.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ostream& operator<<(ostream& s, cadez_discretization& c) {
	const long flagsave = s.setf(ios::scientific|ios::left);
	const int precsave = s.precision(6);
	char *offset = "               ";
	s << offset
			<< "======================="
				"======================================\n";
	s << offset
			<< "| Netap =  " << setw(10) << c.domain_R1.extents(I_Y)
			<< "  Netam =  " << setw(10) << c.domain_R2.extents(I_Y)
			<< "  Neta3 =  " << setw(6) << c.domain_R3.extents(I_Y)
			<< " |\n";
	s << offset
			<< "|   Nsp =  " << setw(10) << c.domain_R1.extents(I_X)
			<< "    Nsm =  " << setw(10) << c.domain_R2.extents(I_X)
			<< "     Ns =  " << setw(6) << c.domain_R3.extents(I_X)
			<< " |\n";
ifelse(NDIM,3,@
	s << offset
			<< "|  Nphi =  " << setw(10) << c.domain_R3.extents(I_W)
			<< "                                       |\n";
@)
	s.unsetf(ios::left); s.setf(ios::right);
	s << offset
			<< "|  deta = " << setw(13) << c.deta
			<< "   ds = " << setw(13) << c.ds
			<< "                |\n";
ifelse(NDIM,3,@
	s << offset
			<< "|  dphi =  " << setw(13) << c.dphi
			<< "                                    |\n";
@)
	s << offset
			<< "|     f = " << setw(13) << c.StoXI_f
			<< "    g = " << setw(13) << c.StoXI_g
			<< "                |\n";
	s << offset
			<< "|   baseP_R1 = " << setw(5) << c.baseP_R1
			<< "    baseP_R2 = " << setw(5) << c.baseP_R2
			<< "  baseP_R3 = " << setw(5) << c.baseP_R3
			<< "  |\n";
	s << offset
			<< "======================="
				"======================================\n";
	s.flags(flagsave);
	s.precision(precsave);
	for(int i=0; i < c.Ninteriors; ++i)
//		s << i+1 << '\t' << c.interiors[i].lower()[0]
//			<< '\t' << c.interiors[i].lower()[1]
//			<< '\t' << c.interiors[i].upper()[0]
//			<< '\t' << c.interiors[i].upper()[1] << '\n';
		s << "Partition : " << setw(3) << i+1 << " : "
			<< setw(3) << c.mapping[i] << " : "
			<< setw(5) << c.interiors[i].size() << " : "
			<< c.interiors[i] << "   :   "
			<< c.coarse_interiors[i] << '\n'
			<< "                              : "
			<< c.extents[i] << "   :   "
			<< c.coarse_extents[i] << '\n'
			<< "                              : "
			<< c.fills[i] << "   :   "
			<< c.coarse_fills[i] << '\n';
	return s;
} // operator<<


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Terminator for cadez_hierarchy.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
cadez_hierarchy::~cadez_hierarchy(){
	for(int i = 0; i < size; i++)
		delete level[i];
	delete level;
	for(int j = 0; j < BS_nlevels; ++j)
		delete BS_level[j];
	delete BS_level;
   delete Mat_R1;
   delete Mat_R2;
   delete Mat_R3;
   delete Upd_R1;
   delete Upd_R2;
   delete Upd_R3;
} // cadez_hierarchy::~cadez_hierarchy


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Define the coarse level Cadez discretization in the hierarchy.
//------------------------------------------------------------------------------
// Based on the coarse level, set up the Block-multigrid levels for
// the Cadez Region 3 solver.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ifelse(NDIM,2,@
void cadez_hierarchy::coarse_level(int nep, int nem, int ne3, int nsp, int nsm){
@,NDIM,3,@
void cadez_hierarchy::coarse_level(int nep, int nem, int ne3,
												int nsp, int nsm, int nphi){
@)
// Define the coarse level discretization in the hierarchy.
	if(level != 0) {
		cerr << "Cannot reset the coarse level of a Cadez Hierarchy!" << endl;
		exit(1);
	}
//
// Compute the Block-multigrid levels for the Cadez Region 3 solver.
	int ns = nsp + nsm;
	int ne = ne3;
ifelse(NDIM,3,@
	int np = nphi;
@)
	BS_nlevels = 1;	// Take level 0 as base of Region 3 solver.
ifelse(NDIM,2,@
#define R3CUTOFFSIZE 32
@,NDIM,3,@
//#define R3CUTOFFSIZE 32
#define R3CUTOFFSIZE 8
@)
#define EVEN(A) ((A)%2 != 1)
#define BIGENOUGH(A) ((A) >= R3CUTOFFSIZE)
// Coarsen until the number of zones in any dimension is odd number or 
// is <= 4.
ifelse(NDIM,2,@
	while(BIGENOUGH(ns) && BIGENOUGH(ne) && EVEN(ns) && EVEN(ne)) {
@,NDIM,3,@
	while(BIGENOUGH(ns) && BIGENOUGH(ne) && BIGENOUGH(np) &&
			EVEN(ns) && EVEN(ne) && EVEN(np)) {
		np /= 2;
@)
		ns /= 2;
		ne /= 2;
		++BS_nlevels;
	}
// Allocate and zero an array of "resize_chunk" pointers for levels.
	level = new cadez_discretization*[resize_chunk];
	size = resize_chunk;
	memset(level, 0, sizeof(cadez_discretization*)*resize_chunk);
// Allocate level 0 and partition it.
	int nparts = mpNodes();
ifelse(NDIM,2,@
	level[0] = new cadez_discretization(domain,Uniform,nep,nem,ne3,nsp,nsm);
@,NDIM,3,@
	level[0] = new cadez_discretization(domain,Uniform,nep,nem,ne3,nsp,nsm,nphi);
@)
	level[0]->domain_partition(nparts,MINSIZE,0,0,BS_nlevels);
	nlevels = 1;
	initialize_level(0,1.0,0,0,0);
//
// Define the levels for the block solver for Region 3.
	if(BS_level != 0) {
		cerr << "Cannot reset the coarse level Block solver!" << endl;
		exit(1);
	}
// Allocate the Cadez Region 3 array of level pointers.
	BS_level = new cadez_discretization*[BS_nlevels];
	BS_level[0] = level[0];	// Assign level 0 to the Region 3 solver.
	int tnsp = nsp;
	int tnsm = nsm;
	int tne3 = ne3;
ifelse(NDIM,3,@
	int tnphi = nphi;
@)
   int baseP = level[0]->baseP_R3;
   nparts -= baseP;
// Allocate and partition all of the multigrid levels.
	for(int i=1; i < BS_nlevels ; ++i){
ifelse(NDIM,2,@
		tnsp /= 2; tnsm /= 2; tne3 /= 2;
		BS_level[i] = new cadez_discretization(domain,Uniform,0,0,tne3,tnsp,tnsm);
@,NDIM,3,@
		tnsp /= 2; tnsm /= 2; tne3 /= 2; tnphi /= 2;
		BS_level[i] = new cadez_discretization(domain,Uniform,
																		0,0,tne3,tnsp,tnsm,tnphi);
@)
		BS_level[i]->domain_partition(nparts,MINSIZE,BS_nlevels-i-1,baseP);
		initialize_level(-i,0.0,0,0,0);
	}
//
// Allocate storage for direct solvers
	const int id = mpMyID();
	const cadez_discretization * coarse12 = level[0];
	const cadez_discretization * coarse3 = BS_level[BS_nlevels-1];
ifelse(NDIM,2,@
	if(coarse12->baseP_R1 == id) {
		const int N = coarse12->domain_R1.size();
		const int KD = coarse12->domain_R1.extents(0);
		Mat_R1 = new double[(KD+1)*N];
		Upd_R1 = new double[N];
	}
	if(coarse12->baseP_R2 == id) {
		const int N = coarse12->domain_R2.size();
		const int KD = coarse12->domain_R2.extents(0);
		Mat_R2 = new double[(KD+1)*N];
		Upd_R2 = new double[N];
	}
	if(coarse3->baseP_R3 == id) {
		const int N = coarse3->domain_R3.size();
		const int KD = coarse3->domain_R3.extents(0);
		Mat_R3 = new double[(KD+1)*N];
		Upd_R3 = new double[N];
	}
@,NDIM,3,@
	if(coarse12->baseP_R1 == id) {
		const int N = coarse12->domain_R1.size();
		const int KD = coarse12->domain_R1.extents(0)*
							coarse12->domain_R1.extents(1);
		Mat_R1 = new double[(KD+1)*N];
		Upd_R1 = new double[N];
	}
	if(coarse12->baseP_R2 == id) {
		const int N = coarse12->domain_R2.size();
		const int KD = coarse12->domain_R2.extents(0)*
							coarse12->domain_R2.extents(1);
		Mat_R2 = new double[(KD+1)*N];
		Upd_R2 = new double[N];
	}
	if(coarse3->baseP_R3 == id) {
		const int N = coarse3->domain_R3.size();
		const int KD = coarse3->domain_R3.extents(0)*
							coarse3->domain_R3.extents(1);
		Mat_R3 = new double[(KD+1)*N];
		Upd_R3 = new double[N];
	}
@)
} // cadez_hierarchy::coarse_level


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Refine the multigrid hierarchy by 1 FULL level.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void cadez_hierarchy::uniform_refine(const int New_Level) {
//	Check the location of the new level in the hierarchy.  If the new level is
//	within the current hierarchy, then see if the old discretization was also
//	Uniform.  If it was uniform, then reuse the old discretization, just update
//	the fields with initialize.  If it was uniform, then create a new
//	discretization and copy the old info with initialize.  If the new level is
//	outsize of the current hierarcy, make sure it is only one level out.
//
	cadez_discretization *Old_Level = 0;
	if(New_Level < nlevels) {
		Old_Level = level[New_Level];
	} else if(New_Level > nlevels) {
		cerr << "Cannot create level " << New_Level << ", level " << New_Level-1
				<< " does not exist!" << endl;
		exit(1);
	} else {
		++nlevels;
	}
//
	if(Old_Level == 0 || !(Old_Level->Is_Uniform())) {
	//
	// Get pointer to current finest level.
		cadez_discretization * oldlevel = level[New_Level-1];
	// Compute Cadez domain sizes for new, refined level.
		const int nep = 2 * oldlevel->domain_R1.extents(I_Y);
		const int nem = 2 * oldlevel->domain_R2.extents(I_Y);
		const int ne3 = 2 * oldlevel->domain_R3.extents(I_Y);
		const int nsp = 2 * oldlevel->domain_R1.extents(I_X);
		const int nsm = 2 * oldlevel->domain_R2.extents(I_X);
ifelse(NDIM,3,@
		const int nphi = 2 * oldlevel->domain_R2.extents(I_W);
@)
	// Allocate and initialize a new level.
		if(New_Level+1 < size) {  // Enough space, just allocate and initialize.
ifelse(NDIM,2,@
			level[New_Level] = new cadez_discretization(domain,Uniform,
																		nep,nem,ne3,nsp,nsm);
@,NDIM,3,@
			level[New_Level] = new cadez_discretization(domain,Uniform,
																		nep,nem,ne3,nsp,nsm,nphi);
@)
		} else {	// Not enough space. Expand level, then allocate and initialize.
			const int tmpsize = size + resize_chunk;
			cadez_discretization ** tmplev = new cadez_discretization*[tmpsize];
			memset(tmplev, 0, sizeof(cadez_discretization*)*tmpsize);
			for(int i = 0; i < size; ++i)
				tmplev[i] = level[i];
ifelse(NDIM,2,@
			tmplev[New_Level] = new cadez_discretization(domain,Uniform,
																		nep,nem,ne3,nsp,nsm);
@,NDIM,3,@
			tmplev[New_Level] = new cadez_discretization(domain,Uniform,
																		nep,nem,ne3,nsp,nsm,nphi);
@)
			delete level;
			level = tmplev;
			size = tmpsize;
		}
	// Partition the new level.
		const int nparts = mpNodes();
		level[New_Level]->domain_partition(nparts,MINSIZE);
		initialize_level(New_Level,1.0,1,0,Old_Level);
	} else if(Old_Level->Is_Uniform()) {
		initialize_level(New_Level,1.0,1,1,Old_Level);
	} else {
		initialize_level(New_Level,1.0,1,0,Old_Level);
	}
	cadez_discretization *lev = level[New_Level-1];
  	for_all_1(i,lev->Refine_Mask)
		lev->Refine_Mask(i).fill(0.0);	// Full refinement coarser Mask now 0.
	end_for_all
} // cadez_hierarchy::uniform_refine


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	Set the finest level in the hierarchy to be level Max_Lev.
//	Delete any old, unused levels in the hierarchy.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void cadez_hierarchy::define_max_level(const int Max_Lev) {
	for(int i = nlevels-1; i > Max_Lev; ++i) {
		delete level[i];
		level[i] = 0;
	}
	nlevels = Max_Lev + 1;
} // cadez_hierarchy::define_max_level


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	Reset any variables and fields to conform to a new set of parameters.
//	Set grid quantities only on level Max_Lev and coarser levels.
//	Set Refine_Mask on level Max_Lev to 1.0.
//	Set Tau's on level Max_Lev to 0.0.
//	Set Refine_Mask on any finer levels to 0.0.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void cadez_hierarchy::New_Parameter_Set(const int Max_Lev) {
	for(int i = -BS_nlevels + 1; i <= Max_Lev; ++i) {
		cadez_discretization & lev = (*this)[i];
		for_all_1(l,lev.KK)
ifelse(NDIM,2,@
			cadez_id(domain.Pzp,domain.Pzm,
						domain.Szp,domain.Szm,domain.Isom,
						lev.KK(l).data(),
						lev.RHOzc(l).data(),lev.Zzc(l).data(),lev.CJACzc(l).data(),
						(int *)(lev.extents+l),(int *)(lev.fills+l));
@,NDIM,3,@
			cadez_id(domain.Pxp,domain.Pyp,domain.Pzp,
						domain.Pxm,domain.Pym,domain.Pzm,
						domain.Sxp,domain.Syp,domain.Szp,
						domain.Sxm,domain.Sym,domain.Szm,domain.Isom,
						lev.KK(l).data(),
						lev.RHOzc(l).data(),lev.Zzc(l).data(),lev.Phi(l).data(),
						lev.CJACzc(l).data(),(int *)(lev.extents+l),
						(int *)(lev.fills+l));
@)
		end_for_all_no_sync
	}
	cadez_discretization & lev = (*this)[Max_Lev];
	for_all_1(l,lev.Refine_Mask)
		lev.Refine_Mask(l).fill(1.0);
		lev.PsiTau(l).fill(0.0);
	end_for_all_no_sync
	for(i = Max_Lev + 1; i < nlevels; ++i) {
		cadez_discretization & lev = (*this)[i];
		for_all_1(l,lev.Refine_Mask)
			lev.Refine_Mask(l).fill(0.0);
		end_for_all_no_sync
	}
} // cadez_hierarchy::New_Parameter_Set


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Print out the entire hierarchy of levels, including the Cadez Region 3
// Block-multigrid solver levels.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void cadez_hierarchy::printlevels(ostream& s) {
	for(int i = -BS_nlevels + 1; i < nlevels ; ++i)
		s << "Level : " << i << '\n' << (*this)[i];
	s << endl;
} // cadez_hierarchy::printlevels


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Return a reference to a given discretization level.
//    Nonnegative indices indicate normal multigrid levels.
//    Negative indices indicate Cadez Region 3 Block-muligrid levels.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
cadez_discretization & cadez_hierarchy::operator[](int ind) {
	if(ind >= 0 && ind < nlevels) {
		return *level[ind];
	} else if(ind < 0 && ind > -BS_nlevels) {
		return *BS_level[-ind];
	} else {
		cerr << "Cadez_hierarchy operator[]--index out of range!" << endl;
		exit(1);
	}
	return *level[0];	// Make the compiler happy.  This is never reached.
} // cadez_hierarchy::operator[]


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	Solve the coarse level (using block multigrid).
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
F_ID cadez_hierarchy::coarse_solve_ID(F_ID res_goal,const int pr) {
	cadez_discretization & c12 = *level[0];
	cadez_discretization & c3 = *BS_level[BS_nlevels-1];
   const int base1 = c12.baseP_R1;	// get the base processors IDs
   const int base2 = c12.baseP_R2;
   const int base3 = c3.baseP_R3;
	F_ID res3, tau3;
//
//	Solve the coarse level using block multigrid.
	const int nodes = mpNodes();
	const int id = mpMyID();
	int loop = 0;
	F_ID res = ID_Residual(c12,1);
	if(res_goal == 0.0) res_goal = res;
	res_goal = (res_goal < res*0.01) ? res_goal : res*0.01;
	if(pr > 1 && id == 0) {
		const long flagsave = cout.setf(ios::scientific|ios::right);
		const int precsave = cout.precision(4);
		cout << "CG G| " << setw(10) << res_goal.Psi << " |" << endl;
		cout << "CG R| " << setw(10) << res.Psi << " |" << endl;
		cout.flags(flagsave);
		cout.precision(precsave);
	}
	while(res > res_goal && loop++ < 20) {
	//	no heterogeneous parallelism for coarse level solution.
		for_all_1(i,c12.PsiD)
			RegionX R1_test = c12.interiors[i]*c12.domain_R1;
			if(!R1_test.empty() && (loop%2 == 1)) {
ifelse(NDIM,2,@
				int KD = c12.domain_R1.extents(0);
				psi_ds(c12.PsiD(i).data(), c12.Psi(i).data(),
							c12.KK(i).data(), c12.PsiRes(i).data(),
							c12.LapX(i).data(), c12.LapY(i).data(),
							c12.Volume(i).data(),
							Mat_R1,Upd_R1,(int *)(c12.extents+i),
							(int *)(c12.interiors+i),KD);
@,NDIM,3,@
				int KD = c12.domain_R1.extents(0)*
							c12.domain_R1.extents(1);
				psi_ds(c12.PsiD(i).data(), c12.Psi(i).data(),
							c12.KK(i).data(), c12.PsiRes(i).data(),
							c12.LapW(i).data(), c12.LapX(i).data(),
							c12.LapY(i).data(), c12.Volume(i).data(),
							Mat_R1,Upd_R1,(int *)(c12.extents+i),
							(int *)(c12.interiors+i),KD);
@)
			}
			RegionX R2_test = c12.interiors[i]*c12.domain_R2;
			if(!R2_test.empty() && (loop%2 == 1)) {
ifelse(NDIM,2,@
				int KD = c12.domain_R2.extents(0);
				psi_ds(c12.PsiD(i).data(), c12.Psi(i).data(),
							c12.KK(i).data(), c12.PsiRes(i).data(),
							c12.LapX(i).data(), c12.LapY(i).data(),
							c12.Volume(i).data(),
							Mat_R2,Upd_R2,(int *)(c12.extents+i),
							(int *)(c12.interiors+i),KD);
@,NDIM,3,@
				int KD = c12.domain_R2.extents(0)*
							c12.domain_R2.extents(1);
				psi_ds(c12.PsiD(i).data(), c12.Psi(i).data(),
							c12.KK(i).data(), c12.PsiRes(i).data(),
							c12.LapW(i).data(), c12.LapX(i).data(),
							c12.LapY(i).data(), c12.Volume(i).data(),
							Mat_R2,Upd_R2,(int *)(c12.extents+i),
							(int *)(c12.interiors+i),KD);
@)
			}
			if(BS_nlevels == 1 && (loop%2 == 0)) {
				RegionX R3_test = c3.interiors[i]*c3.domain_R3;
				if(!R3_test.empty()) {
ifelse(NDIM,2,@
					int KD = c3.domain_R3.extents(0);
					psi_ds(c3.PsiD(i).data(), c3.Psi(i).data(),
								c3.KK(i).data(), c3.PsiRes(i).data(),
								c3.LapX(i).data(), c3.LapY(i).data(),
								c3.Volume(i).data(),
								Mat_R3,Upd_R3,(int *)(c3.extents+i),
								(int *)(c3.interiors+i),KD);
@,NDIM,3,@
					int KD = c3.domain_R3.extents(0)*
								c3.domain_R3.extents(1);
					psi_ds(c3.PsiD(i).data(), c3.Psi(i).data(),
								c3.KK(i).data(), c3.PsiRes(i).data(),
								c3.LapW(i).data(), c3.LapX(i).data(),
								c3.LapY(i).data(), c3.Volume(i).data(),
								Mat_R3,Upd_R3,(int *)(c3.extents+i),
								(int *)(c3.interiors+i),KD);
@)
				}
			}
		end_for_all
		if(BS_nlevels != 1 && (loop%2 == 0)) {
			mg3(0,res3,tau3,pr);
		}
	//	Synchronize the coarse level 
		c12.fill_patch(c12.PsiD);
		c12.sync_fields();
	// Compute residual
		res = ID_Residual(c12,1);
		if(pr > 1 && id == 0) {
			const long flagsave = cout.setf(ios::scientific|ios::right);
			const int precsave = cout.precision(4);
			cout << "CG" << setw(2) << loop << "| "
									<< setw(10) << res.Psi << " |" << endl;
			cout.flags(flagsave);
			cout.precision(precsave);
		}
	}
	return res;	// return the value of the residual
} // cadez_hierarchy::coarse_solve_ID
